<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_Ubicacion.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Mantenimiento de los registros de la tabla MST_Ubicacion */
abstract class BaseMST_UbicacionDP extends MST_UbicacionBV
{
    /* Constructor ( Establece los valores desde un objeto MST_UbicacionBN ) */
    public function __construct( MST_UbicacionBN $o_MST_UbicacionBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_UbicacionBN ) )
        {
            $this->setByBN( $o_MST_UbicacionBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_UbicacionBN */
    public function setByBN( MST_UbicacionBN $o_MST_UbicacionBN )
    {
        if ( !is_null( $o_MST_UbicacionBN->getIdUbicacion() ) )
        {
            $this->setIdUbicacion( $o_MST_UbicacionBN->getIdUbicacion() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_UbicacionBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MST_UbicacionBN->getIdSucursal() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getIdUbicacionPertenece() ) )
        {
            $this->setIdUbicacionPertenece( $o_MST_UbicacionBN->getIdUbicacionPertenece() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getIdTipoUbicacion() ) )
        {
            $this->setIdTipoUbicacion( $o_MST_UbicacionBN->getIdTipoUbicacion() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getIdCategoria() ) )
        {
            $this->setIdCategoria( $o_MST_UbicacionBN->getIdCategoria() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getIdPisos() ) )
        {
            $this->setIdPisos( $o_MST_UbicacionBN->getIdPisos() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getTopePersonas() ) )
        {
            $this->setTopePersonas( $o_MST_UbicacionBN->getTopePersonas() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getTolerancia() ) )
        {
            $this->setTolerancia( $o_MST_UbicacionBN->getTolerancia() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getNombre() ) )
        {
            $this->setNombre( $o_MST_UbicacionBN->getNombre() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getDescripcion() ) )
        {
            $this->setDescripcion( $o_MST_UbicacionBN->getDescripcion() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_UbicacionBN->getEstado() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_UbicacionBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_UbicacionBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_UbicacionBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_UbicacionBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_UbicacionBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_UbicacionFN = new MST_UbicacionFN();
        $o_MST_UbicacionBN = $o_MST_UbicacionFN->selectByPk( $this->getIdUbicacion() );
        if ( is_null( $o_MST_UbicacionBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_Ubicacion ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdUbicacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUbicacion";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUbicacion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUbicacionPertenece() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUbicacionPertenece";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdUbicacionPertenece()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoUbicacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoUbicacion";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdTipoUbicacion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCategoria() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCategoria";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCategoria()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPisos() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPisos";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPisos()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTopePersonas() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TopePersonas";
                $s_SQLQuery2 .= $s_Separator."".$this->getTopePersonas()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTolerancia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Tolerancia";
                $s_SQLQuery2 .= $s_Separator."".$this->getTolerancia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Nombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Descripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_Ubicacion SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUbicacionPertenece() ) )
            {
                $s_SQLQuery .= $s_Separator."IdUbicacionPertenece = ".$this->getIdUbicacionPertenece()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoUbicacion() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoUbicacion = ".$this->getIdTipoUbicacion()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCategoria() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCategoria = ".$this->getIdCategoria()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPisos() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPisos = ".$this->getIdPisos()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTopePersonas() ) )
            {
                $s_SQLQuery .= $s_Separator."TopePersonas = ".$this->getTopePersonas()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTolerancia() ) )
            {
                $s_SQLQuery .= $s_Separator."Tolerancia = ".$this->getTolerancia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."Nombre = '".$this->getNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."Descripcion = '".$this->getDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdUbicacion = ".$this->getIdUbicacion().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_Ubicacion WHERE  IdUbicacion = ".$this->getIdUbicacion().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>